<template>
  <div class="contract-page-detail">
    <transition name="fadeIn">
      <ObForm
        v-if="isVisible"
        ref="form"
        :form-data="contract"
        :form-model="formModel"
        :is-show-controls="false"
        :is-show-required="true"
      >
        <ObContractTemplate
          :tabs-items="tabsItems"
          :active-tab="activeTab"
          :disabledBtn="disabledBtn"
          :is-all-validate="isAllValidate"
          @on-change-tab="onChangeTab"
          :validator="validator"
        >
          <div slot="left">
            <transition name="fadeIn" mode="out-in">
              <keep-alive>
                <component
                  :is="currentComponent"
                  :validator="validator"
                  :active-tab="activeTab"
                />
              </keep-alive>
            </transition>
          </div>
          <RightPanel
            :validator="validator"
            :is-next-tab="Boolean(isNextTab)"
            :is-prev-tab="Boolean(isPrevTab)"
            :active-tab="activeTab"
            data-qa="rightPanel"
            :disabledBtn="disabledBtn"
            @on-click-next="nextTab"
            @on-click-prev="prevTab"
            @on-change-all-validate="onChangeAllValidate"
            @on-click-close="onClickClose"
            slot="right"
          />
        </ObContractTemplate>
        <transition :name="transitionByState" mode="out-in">
          <keep-alive>
            <Component
              :is="serviceDetailComponent"
              v-if="isViewServiceDetail"
              class="contract-directions"
            />
          </keep-alive>
        </transition>
      </ObForm>
    </transition>
  </div>
</template>

<script>
import { mapMutations, mapState, mapActions, mapGetters } from 'vuex'
import api from '@/api'
import ObContractTemplate from '@/components/Contract/obContractTemplate.vue'
import ObButton from 'common-components/src/obComponents/obButton'
import FrontPage from '@/components/Contract/detail/frontPage'
import Services from '@/components/Contract/detail/services'
import TarificationTracking from '@/components/Contract/detail/services/TarificationTracking'
import TariffAgreement from '@/components/Contract/detail/tariffAgreement'
// import ConditionPayment from '@/components/Contract/detail/conditionPayment'
// import Regulations from '@/components/Contract/detail/regulations'
// import Claims from '@/components/Contract/detail/claims'
// import Workflow from '@/components/Contract/detail/workflow'
// import KPI from '@/components/Contract/detail/kpi'
import RightPanel from '@/components/Contract/detail/RightPanel'
import Directions from '@/components/Contract/detail/services/directions/List'
import DirectionsMultistop from '@/components/Contract/detail/services/directions/ListMultistop'
import Locations from '@/components/Contract/detail/services/locations/List'
import ObForm from 'common-components/src/obComponents/obForm'
import { email, required, minLength, requiredIf } from 'vuelidate/lib/validators'
import moment from 'moment'

const fromDateLarger = (value, vm) => {
  return Boolean(vm && (moment(vm.toDate).diff(moment(value), 'days') >= 0 || vm.isTimeless || !vm.toDate))
}

const toDateUnder = (value, vm) => {
  return Boolean(vm && (moment(vm.fromDate).diff(moment(value), 'days') <= 0 || vm.isTimeless || !vm.fromDate))
}

export default {
  name: 'ContractDetail',
  components: {
    ObContractTemplate,
    RightPanel,
    ObForm,
    ObButton,
    Directions,
    Locations,
    TariffAgreement
  },
  data () {
    return {
      initInfo: {},
      currentRole: null,
      activeTab: this.$route.query.tab || 'frontPage',
      isAllValidate: false,
      validator: {}
    }
  },
  async mounted () {
    await this.getData()
  },
  beforeDestroy () {
    this.clearContractState()
  },
  watch: {
    '$route' (val, oldVal) {
      if (val.params.id !== oldVal.params.id) {
        this.getData()
      }
    }
  },
  computed: {
    ...mapState({
      contract: state => state.contract.contract
    }),
    ...mapGetters({
      isViewMain: 'contract/isViewMain',
      isViewServiceDetail: 'contract/isViewServiceDetail',
      isTracking: 'contract/isTracking',
      isTariffAgreement: 'contract/isTariffAgreement',
      isTitul: 'contract/isTitul',
      service: 'contract/service',
      isVisible: 'contract/isVisible'
    }),
    contractId () {
      return this.$route && this.$route.params.id
    },
    diff () {
      return moment(this.contract.fromDate).startOf('day').diff(moment(this.contract?.parentContractData?.fromDate), 'days')
    },
    formModel () {
      const _self = this
      let datesValidator = {}

      if (this.isTariffAgreement) {
        datesValidator = {
          fromDate: {
            value: '',
            validator: {
              required,
              fromDateTariffAgreement: {
                method:  (value) => {
                  return Boolean(moment(value).startOf('day').diff(moment(_self.contract?.parentContractData?.fromDate), 'days') >= 0)
                },
                error: 'Дата начала должна быть не ранее даты начала действия договора'
              },
              fromDateLarger: {
                method: fromDateLarger,
                error: 'Дата начала должна быть меньше даты окончания'
              }
            }
          },
          toDate: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return !_self.contract?.parentContractData?.isTimeless
              }),
              toDateTariffAgreement: {
                method:  (value) => {
                  return Boolean(_self.contract?.parentContractData?.isTimeless || moment(value).startOf('day').diff(moment(_self.contract?.parentContractData?.toDate), 'days') <= 0)
                },
                error: 'Дата окончания должна быть не позднее даты окончания действия договора'
              },
              toDateUnder: {
                method: toDateUnder,
                error: 'Дата окончания должна быть больше даты начала'
              }
            }
          },
        }
      } else {
        datesValidator = {
          fromDate: {
            value: '',
            validator: {
              required,
              fromDateLarger: {
                method: fromDateLarger,
                error: 'Дата начала должна быть меньше даты окончания'
              }
            }
          },
          toDate: {
            value: '',
            validator: {
              required: requiredIf(function () {
                return !this.formData.isTimeless
              }),
              toDateUnder: {
                method: toDateUnder,
                error: 'Дата окончания должна быть больше даты начала'
              }
            }
          },
        }
      }

      return {
        clientEmail: {
          value: '',
          validator: {
            // required: requiredIf(function () {
            //   return this.formData.needNotifyClientByMail
            // }),
            email: {
              method: email,
              error: 'Некорректный email'
            }
          }
        },
        doerEmail: {
          value: '',
          validator: {
            // required: requiredIf(function () {
            //   return this.formData.needNotifyDoerByMail
            // }),
            email: {
              method: email,
              error: 'Некорректный email'
            }
          }
        },
        clientPhone: {
          value: '',
          validator: {
            required: requiredIf(function () {
              return this.formData.needNotifyClientByPhone
            }),
            minLength: {
              method: minLength(10),
              error: 'Некорректный номер телефона'
            }
          }
        },
        doerPhone: {
          value: '',
          validator: {
            required: requiredIf(function () {
              return this.formData.needNotifyDoerByPhone
            }),
            minLength: {
              method: minLength(10),
              error: 'Некорректный номер телефона'
            }
          }
        },
        ...datesValidator
      }
    },
    tabsItems () {
      if (this.isTariffAgreement) {
        return [
          {
            uuid: 'frontPage',
            title: 'Титул',
            component: FrontPage
          },
          {
            uuid: 'tarification',
            title: 'Тарифы',
            component: Services
          },
        ]
      } else {
        return [
          {
            uuid: 'frontPage',
            title: 'Титул',
            component: FrontPage
          },
          {
            uuid: this.isTitul ? 'tariff_agreement' : 'tarification',
            title: this.isTitul ? 'Тарифные соглашения' : 'Тарификация',
            isDisabled: !this.contract.doerUuid,
            component: this.isTitul ? TariffAgreement : this.isTracking ? TarificationTracking : Services
          },
          // {
          //   uuid: 'conditionPayment',
          //   title: 'Условия оплаты',
          //   component: ConditionPayment,
          //   isDisabled: true
          // },
          // {
          //   uuid: 'regulations',
          //   title: 'Нормативы',
          //   component: Regulations,
          //   isDisabled: true
          // },
          // {
          //   uuid: 'claims',
          //   title: 'Претензии',
          //   component: Claims,
          //   isDisabled: true
          // },
          // {
          //   uuid: 'workflow',
          //   title: 'Документооборот',
          //   component: Workflow,
          //   isDisabled: true
          // },
          // {
          //   uuid: 'kpi',
          //   title: 'KPI',
          //   component: KPI,
          //   isDisabled: true
          // }
        ]
      }
    },
    serviceDetailComponent () {
      const componentMap = {
        WHERE: Locations,
        FROM_TO: Directions,
        MULTISTOP: DirectionsMultistop
      }
      return componentMap[this.service.serviceCaste === 'MULTISTOP' ? 'MULTISTOP' : this.service.geography]
    },
    currentTabIndex () {
      let currentTabIndex
      this.tabsItems.forEach((item, index) => {
        if (item.uuid === this.activeTab) {
          currentTabIndex = index
        }
      })

      return currentTabIndex
    },
    disabledBtn () {
      return !this.tabsItems[this.currentTabIndex + 1] || this.tabsItems[this.currentTabIndex + 1].isDisabled
    },
    isNextTab () {
      if (this.tabsItems[this.currentTabIndex + 1]) {
        return this.tabsItems[this.currentTabIndex + 1].uuid
      } else {
        return false
      }
    },
    isPrevTab () {
      if (this.currentTabIndex && this.tabsItems[this.currentTabIndex - 1]) {
        return this.tabsItems[this.currentTabIndex - 1].uuid
      } else {
        return false
      }
    },
    currentComponent () {
      let currentItem = this.tabsItems.find(item => item.uuid === this.activeTab)
      return currentItem ? currentItem.component : FrontPage
    },
    transitionByState () {
      return 'fadeScale'
    }
  },
  methods: {
    ...mapMutations({
      setViewState: 'contract/setViewState'
    }),
    ...mapActions({
      getContractData: 'contract/getContractData',
      clearContractState: 'contract/clearState'
    }),
    async getData () {
      window.scrollTo(0, 0)
      try {
        if (!this.$route.query.tab) {
          this.activeTab = 'frontPage'
        }
        await this.getContractData({ uuid: this.contractId, init: true })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Договор не найден'
        })
        this.$router.replace({ name: 'contracts__draft' })
      }

      this.validator = this.$refs.form?.$v || {}
    },
    onChangeTab (val) {
      this.activeTab = val
    },
    onChangeAllValidate (val) {
      this.isAllValidate = val
    },
    nextTab () {
      if (this.isNextTab && this.isNextTab !== 'conditionPayment') {
        this.activeTab = this.isNextTab
      }
    },
    prevTab () {
      if (this.isPrevTab) {
        this.activeTab = this.isPrevTab
      }
    },
    async onClickClose () {
      let result = await this.saveContract()
      if (result) {
        this.$router.push({name: 'contracts__draft'})
      }
    },
    async saveContract () {
      let notificationId = new Date().getTime()+'save'
      try {
        this.$notification({ type: 'system_notification_in_load', message: 'Сохранение', id: notificationId })
        await api.contract.saveContractDraft({ data: this.contract, type: this.contract.contractTypeCode })
        this.$notification({
          type: 'system_notification_success',
          message: 'Сохранено'
        })
        return true
      } catch (e) {
        console.error(e)
        this.$notification({
          type: 'system_notification_error',
          message: 'Не сохранено'
        })
        return false
      } finally {
        this.$notification({ event: 'close', id: notificationId })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
  .contract-page-detail {
    display: flex;
    width: 100%;
    padding: 12px 20px 20px;

    & > div {
      display: flex;
    }

    .contract-directions {
      position: absolute;
      z-index: 100;
      top: 0;
      left: 0;
      width: 100%;
      height: 100%;
    }
  }

  .fadeScale-enter, .fadeScale-leave-to {
    transform: translateY(100px);
    opacity: 0;
  }

  .fadeScale-enter-active, .fadeScale-leave-active {
    transition: all 0.3s ease-out;
  }

  .fadeIn-enter, .fadeIn-leave-to {
    opacity: 0;
  }

  .fadeIn-enter-active, .fadeIn-leave-active {
    transition: opacity 0.2s linear;
  }

  .tariff-block {
    min-height: 80vh;
    margin: 12px 20px 0px;
    background-color: $background-white;
  }
</style>

<style lang="scss">
  .contract-page-detail {
    border-radius: 3px;
    .ob-form-container {
      width: 100%;
      .form-body {
        display: flex;
        flex-direction: column;
        width: 100%;
        & > div {
          flex-grow: 2;
        }
      }
    }
  }
</style>
